unit DbFloat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls;

type

  TSetCountry = (English,Danish,German);

  TDBFloatEdit = class(TDBEdit)
  private
    { Private declarations }
    FDigits      : byte;
    FMin,FMax    : extended;
    fdec         : char;
    fShowError   : Boolean;
    fertext      : String;
    fertextMax   : string;
    fertextMin   : string;
    fertextMust  : String;
    fertextminval: string;
    fertextmaxval: string;
    foldval      : extended;
    fAllowNull   : Boolean;
    fMaxLength   : Integer;
    fLangauge    : TSetCountry;

  protected
    { Protected declarations }
    procedure setvalue(Newvalue : extended);
    procedure setmin(Newvalue : extended);
    procedure setmax(Newvalue : extended);
    procedure setdigits(Newvalue : byte);
    function  getvalue : extended;
    procedure KeyPress(var Key: Char); override;
    procedure doexit;override;
    procedure doEnter;override;
  public
    { Public declarations }
  published
    { Published declarations }
    property Digits   : byte read FDigits write setDigits;
    property Value    : extended read getvalue write setValue;
    property Min : extended read Fmin write setMin;
    property Max : extended read Fmax write setmax;
    property ShowError : Boolean read fShowError write fShowError;
    property ErrorMessageMax :string read fertextMax write fertextMax;
    property ErrorMessageMin :string read fertextMin write fertextMin;
    property ErrorMessageMinVal :string read fertextMinval write fertextMinval;
    property ErrorMessageMaxVal :string read fertextMaxval write fertextMaxval;
    property ErrorText : string read fertext write fertext;
    property ErrorMust : string read fertextMust write fertextMust;
    property MaxLength : Integer read FmaxLength;   // Maxlength will not be visible
    Property AllowNull : Boolean Read FAllowNull write FAllowNull;
    constructor create (aowner : TComponent);override;
  end;

procedure Register;


implementation

constructor TDBFloatEdit.create (aowner : TComponent);
begin
     inherited create(aowner);
     fdec    := decimalseparator;
     fdigits := 1;
     fmin    := 0;
     fmax    := 99999999.9;
     fAllowNull := True;
     fShowError := True;
     fLangauge  := Danish;

      Case fLangauge of

          English : Begin
                     ErrorMessageminval:='The Min-Value is to large !';
                     ErrorMessagemaxval:='The Max-Value is to small !' ;
                     ErrorMessageMax := 'The value must be under ';
                     ErrorMessageMin := 'The value must be over ';
                     ErrorMust := 'The field must have a value';
                     ErrorText := 'Error';
                    end;

          Danish  : Begin
                     errorMessageMinVal:='Minimun vrdien skal vre ' + #13 + 'mindre end maximum vrdien !';
                     errorMessageMaxVal:='Maximum vrdien skal vre ' + #13 + 'strre end minumum vrdien !' ;
                     ErrorMessageMax := 'Vrdien m maximum vre ';
                     ErrorMessageMin := 'Vrdien m minimum vre ';
                     ErrorMust := 'Feltet skal udfyldes.';
                     ErrorText := 'Fejl';
                    end;

          German  : Begin
                     ErrorMessageminval:='Der Min-Wert ist zu gro !';
                     ErrorMessagemaxval:='Der Max-Wert ist zu klein !'  ;
                     ErrorMessageMax := 'Der Wert mu kleiner sein als ';
                     ErrorMessageMin := 'Der Wert mu grer sein als ';
                     ErrorMust := 'Das Feld mu einen Wert besitzen';
                     ErrorText  := 'Fehler';
                    end;
      end;


end;

procedure Register;
begin
  RegisterComponents('Data Controls', [TDBFloatEdit]);
end;

procedure TDBFloatEdit.doenter;
begin
     foldval:=getvalue;
     inherited;
end;

procedure TDBFloatEdit.doexit;
var ts : string;
    result:extended;
begin
     ts := text;
     inherited;
      If (ts = '') And (AllowNull) Then
       Begin

       end
      Else
       Begin
        try
           result := strtofloat(ts);
        except

           if fShowError then
             Begin
               If ts = '' then MessageDlg(fErTextMust, mtWarning ,[mbOk], 0)
              Else
               // showmessage(fertext);
             end;

           setvalue(foldval);
           selectall;
           setfocus;
           exit;
        end;
        if (result < fmin) or
           (result > fmax) then
           begin

             if fShowError then
              Begin
                If (result < fmin) Then
                  MessageDlg(fErTextMin + floattostrf(fmin,fffixed,18,fdigits),mtInformation, [mbOk], 0);
                If (result > fmax) Then
                  MessageDlg(fErTextMax + floattostrf(fMax,fffixed,18,fdigits),mtInformation, [mbOk], 0);
              end;
             setvalue(foldval);
             selectall;
             setfocus;
             exit;
           end;
        // Ausgabe formatieren
        text := floattostrf(result,fffixed,18,fdigits);
        value:=strtofloat(text);
        inherited;
       end;
end;

procedure TDBFloatEdit.setvalue(Newvalue : extended);
var tmp : string;
begin
        if newvalue > fmax then begin
           if fShowError then showmessage(fertextMax);
           newvalue := fmax;
        end;
        if newvalue < fmin then begin
           if fShowError then showmessage(fertextMin);
           newvalue := fmin;
        end;
        tmp := floattostrf(newvalue,fffixed,18,fdigits);
        text:=tmp;
end;

function TDBFloatedit.getvalue : extended;
var ts : string;
begin
        ts := text;

        If Not AllowNull Then
         Begin
          if (ts = '-') or (ts = fdec) or (ts = '') then ts := '0';
         end
        Else
         Begin
          if (ts = '-') or (ts = fdec) or (ts = '') then ts := '';
         end;

        IF ts <> '' Then
         Begin
           try
              result := strtofloat(ts);
           except
              //if fertext <> notext then showmessage(fertext);
              result := fmin;
           end;
           if result < fmin then begin
              //if fertext <> notext then showmessage(fertext);
              result := fmin;
           end;
           if result > fmax then begin
              //if fertext <> notext then showmessage(fertext);
              result := fmax;
           end;
         end
        else
         result := 0;
end;

procedure TDBFloatEdit.setdigits;
begin
     if fdigits <> newValue then
      begin
        if newvalue > 18 then newvalue := 18;
        fdigits := newvalue;
        setvalue(getvalue);
      end;
end;

procedure TDBFloatEdit.setmin;
begin
     if fmin <> newValue then begin
        if fmin > fmax then begin
	   showmessage(fertextminval);
           newvalue := fmax;
	end;
	fmin := newvalue;
     If (newValue = null) and (AllowNull) Then
        Begin
        end
       Else
        setvalue(getvalue);
     end;
end;

procedure TDBFloatEdit.setmax;
begin
     if fmax <> newValue then begin
        if fmin > fmax then begin
	   showmessage(fertextmaxval);
           newvalue := fmin;
	end;
        fmax := newvalue;
        If (newValue = null) and (AllowNull) Then
           Begin
           end
         Else
           setvalue(getvalue);
     end;
end;


procedure TDBFloatedit.keypress;
var    ts           : string;
   //  result           : extended;
begin
     if key = #27 then begin  // ESC
        setvalue(foldval);
        selectall;
        // inherited;
        exit;
     end;
     if key < #32 then begin   // SPACE
        inherited;
        exit;
     end;

     ts := copy(text,1,selstart)+copy(text,selstart+sellength+1,500);

     if (key <'0') or (key > '9') then if (key <> fdec) and (key <> '-') then begin
        inherited;
        key := #0;
        exit;
     end;

     if key = fdec then if pos(fdec,ts) <> 0 then begin
        inherited;
        key := #0;
        exit;
     end;
     if key = '-' then if pos('-',ts) <> 0 then begin
        inherited;
        key := #0;
        exit;
     end;
     if key = '-' then if fmin >= 0 then begin // Remove '-' if Min = 0
        inherited;
        key := #0;
        exit;
     end;
     if key = fdec then if fdigits = 0 then begin // Remove fdec if digits = o
        inherited;
        key := #0;
        exit;
     end;
     // seltext durch key ersetzen

     ts := copy(text,1,selstart)+key+copy(text,selstart+sellength+1,500);

     // berprfen, ob gltiger wert;
     if key > #32 then
        if pos(fdec,ts)<> 0 then
          begin
            if length(ts)-pos(fdec,ts) > fdigits then
                begin
                  inherited;
                  key := #0;
                  exit;
                end;
          end;

     if key = '-' then if pos('-',ts) <> 1 then begin // Taking care of '-', mus only be at the first place
        inherited;
        key := #0;
        exit;
     end;

     if ts ='' then begin   // put Fmin into text if ''
        inherited;key := #0;
        text := floattostrf(fmin,fffixed,18,fdigits);selectall;
        exit;
     end;
     if ts = '-' then begin
        inherited;key:=#0;
        text := '-0';selstart := 1;sellength:=1;
        exit;
     end;

     if ts = fdec then begin
        inherited;key:=#0;
        text := '0'+fdec+'0';
        selstart :=2;
        sellength:=1;
        exit;
     end;
     inherited;
end;



end.
